<?php

//---------------------------------------自定义分类法------------------------------
function my_custom_tuiguang(){
    $labels = array(
        'menu_name'             => '推广',
        'name'                  => '推广',
        'singular_name'         => '推广',
        'add_new'               => '添加推广',
        'add_new_item'          => '添加推广',
        'edit_item'             => '编辑推广',
        'new_item'              => '新推广',
        'all_items'             => '所有推广',
        'view_item'             => '查看推广',
        'search_items'          => '搜索推广',
        'not_found'             => '无内容',
        'not_found_in_trash'    => '无内容',
    );
    $args = array(
        'labels'                => $labels,
        'description'           => '',
        'public'                => true,
        'publicly_queryable'    => true,
        'show_ui'               => true,
        'show_in_menu'          => true,
        'query_var'             => true,
        'rewrite'               => true,
        'capability_type'       => 'post',
        'has_archive'           => true,
        'hierarchical'          => false,
        'menu_position'         => 5,
        'menu_icon'             => 'dashicons-cart',
        'supports'              => array( 'title','thumbnail','custom-fields' )
    );
    register_post_type('tuiguang',$args);
}
add_action('init', 'my_custom_tuiguang');



//推广文章url重写 如只留id将tuiguang/去掉
function custom_tuiguang_link( $link, $post = 0 ){
    if ( $post->post_type == 'tuiguang' ){
        return home_url( 'tuiguang/' . $post->ID .'.html' );
    } else {
        return $link;
    }
}
add_filter('post_type_link', 'custom_tuiguang_link', 1, 3);

function rewrites_tuiguang(){
    add_rewrite_rule(
        'tuiguang/([0-9]+)?.html$',
        'index.php?post_type=tuiguang&p=$matches[1]',
        'top' );
    add_rewrite_rule(
        'tuiguang/([0-9]+)?.html/comment-page-([0-9]{1,})$',
        'index.php?post_type=tuiguang&p=$matches[1]&cpage=$matches[2]',
        'top'
        );
    }
add_action( 'init', 'rewrites_tuiguang' );



// // ---------------------------------------推广字段------------------------------

//Register Meta box
add_action( 'add_meta_boxes', function() {
    add_meta_box( 'wpdocs-id', '推广参数', 'wpdocs_field_cb', 'tuiguang', 'normal', 'high' );
} );

//Meta callback function
function wpdocs_field_cb( $post ) {
    $ds_leixing = get_post_meta( $post->ID, 'ds_leixing', true );
    $ds_tedian = get_post_meta( $post->ID, 'ds_tedian', true );
    $ds_xiazai = get_post_meta( $post->ID, 'ds_xiazai', true );
    ?>
    <br>
    <label><b>类型属性</b></label>
    <input type="text" name="ds_leixing" value="<?php echo esc_attr( $ds_leixing ) ?>" style="width:400px;margin-left:12px;">
    <br><br>
    <label><b>特点属性</b></label>
    <input type="text" name="ds_tedian" value="<?php echo esc_attr( $ds_tedian ) ?>" style="width:400px;margin-left:12px;">
    <br><br>
    <label><b>下载链接</b></label>
    <input type="text" name="ds_xiazai" value="<?php echo esc_attr( $ds_xiazai ) ?>" style="width:400px;margin-left:12px;">
    <br><br>
    <?php
}

//save meta value with save post hook
add_action( 'save_post', function( $post_id ) {
    if ( isset( $_POST['ds_leixing'] ) ) {
        update_post_meta( $post_id, 'ds_leixing', $_POST['ds_leixing'] );
    }
    if ( isset( $_POST['ds_tedian'] ) ) {
        update_post_meta( $post_id, 'ds_tedian', $_POST['ds_tedian'] );
    }
    if ( isset( $_POST['ds_xiazai'] ) ) {
        update_post_meta( $post_id, 'ds_xiazai', $_POST['ds_xiazai'] );
    }
} );

// show meta value after post content
add_filter( 'the_content', function( $content ) {
    $meta_val = get_post_meta( get_the_ID(), 'ds_leixing', true );
    $meta_val = get_post_meta( get_the_ID(), 'ds_tedian', true );
    $meta_val = get_post_meta( get_the_ID(), 'ds_xiazai', true );
    return $content . $meta_val;
} );




// ---------------------------------------简码设置 用法 [tg p="1"]------------------------------

//创建回调函数
function recent_posts_function($atts){
    extract( shortcode_atts( array( 'p' => 1, ), $atts) );
    query_posts( array( 'ignore_sticky_posts'=>true, 'p'=>$p, 'posts_per_page'=>1, 'post_type'=>'tuiguang' ) );
    while( have_posts() ): the_post();

    $ds_leixing = get_post_meta($p, "ds_leixing", true);
    $ds_tedian = get_post_meta($p, "ds_tedian", true);
    $ds_xiazai = get_post_meta($p, "ds_xiazai", true);
    $ds_pic = wp_get_attachment_image_src(get_post_thumbnail_id($p), array(300,300,true));
    $ds_xiazai_go = '';

    if (wp_is_mobile()) {
        $ds_xiazai_go = '<a class="t_g_box" href="'.$ds_xiazai.'">';
    } else {
        $ds_xiazai_go = '<a rel="external nofollow" data-fancybox data-type="iframe" data-preload="false" data-width="300" data-height="300" data-caption="手机扫一扫，下载'.get_the_title().'" class="t_g_box" href="https://api.qrserver.com/v1/create-qr-code/?data='.$ds_xiazai.'&size=260x260&margin=20">';
    }

    $return_string = $ds_xiazai_go;
    $return_string .= '<img src="'.$ds_pic[0].'" alt="">';
    $return_string .= '<div class="t_g_box_bt">';
    $return_string .= '<div class="t_g_box_bt_1">'.get_the_title().'</div>';
    $return_string .= '<div class="t_g_box_bt_2"><span>类型:</span>'.$ds_leixing.'</div>';
    $return_string .= '<div class="t_g_box_bt_2"><span>特点:</span>'.$ds_tedian.'</div>';
    $return_string .= '</div>';
    $return_string .= '<span class="t_g_box_xz">点击下载</span>';
    $return_string .= '</a>';

    endwhile;wp_reset_query();

    return $return_string;
}

//注册短代码
function register_shortcodes(){
   add_shortcode('tg', 'recent_posts_function');
}

//Hook
add_action( 'init', 'register_shortcodes');


// ---------------------------------------引入css js------------------------------

function custom_script() {
if (is_single()) {
?>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fancyapps/ui/dist/fancybox.css"/>
<script src="https://cdn.jsdelivr.net/npm/@fancyapps/ui@4.0/dist/fancybox.umd.js"></script>
<style>
.t_g_box {display: flex;border: 1px solid #e5e5e5;border-radius: 6px;margin-bottom: 20px;padding: 20px;align-items: center;justify-content: flex-start;position: relative;}
.t_g_box img {width: 70px;border-radius: 10px;margin-right: 20px;}
.t_g_box .t_g_box_bt { }
.t_g_box .t_g_box_bt .t_g_box_bt_1 {font-weight: bold;margin-bottom: 5px;color: #333;}
.t_g_box .t_g_box_bt .t_g_box_bt_2 {font-size: 14px;color: #6c6c6c;}
.t_g_box .t_g_box_bt .t_g_box_bt_2 span {margin-right: 8px;}
.t_g_box .t_g_box_xz {position: absolute;right: 20px;top: 40px;background: #fd2c2c;color: #fff;padding: 8px 20px;font-size: 12px;border-radius: 20px;}
.fancybox__content{padding: 20px;}
.fancybox__content iframe{background:none;border:none;}
@media (max-width:768px){
    .t_g_box{padding:10px;}
    .t_g_box img{width:50px;margin-right:10px;}
    .t_g_box .t_g_box_bt .t_g_box_bt_1{font-size: 14px;margin-bottom: 0;}
    .t_g_box .t_g_box_bt .t_g_box_bt_2{font-size: 12px;}
    .t_g_box .t_g_box_xz{top:12px;padding:3px 14px;}
}
</style>
<?php } }
add_action( 'wp_footer', 'custom_script' );